#include "skse/PluginAPI.h"
#include "skse/skse_version.h"
#include <process.h>

//IDebugLog	gLog("skse_double_cursor_fix_plugin.log");

//PluginHandle	g_pluginHandle = kPluginHandle_Invalid;

WNDPROC oldWndProc = NULL;
HANDLE hThread = NULL;

LRESULT CALLBACK MyWndProc(__in  HWND hWnd, __in  UINT uMsg, __in  WPARAM wParam, __in  LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_ACTIVATE:
		{
			//_MESSAGE("hide cursor");

			if(LOWORD(wParam) > 0)
			{
				while(ShowCursor(FALSE) > -1);
			}
			else
			{
				while(ShowCursor(TRUE) < 0);
			}
		}
	}
	return CallWindowProc(oldWndProc, hWnd, uMsg, wParam, lParam);
}

unsigned __stdcall MyThreadProc( void* pArguments )
{
	while(!oldWndProc)
	{
/*
		size_t iter=0;
		++iter;
*/
		HWND hWnd = FindWindow("Skyrim",NULL);
		if(hWnd && hWnd != INVALID_HANDLE_VALUE)
		{
			//_MESSAGE("Skyrim window found after %u tries",iter);
			oldWndProc = (WNDPROC) SetWindowLongPtr(hWnd,GWLP_WNDPROC,(LONG_PTR)MyWndProc);
		}
		Sleep(1000);
	}
	_endthreadex(0);
	return 0;
}

extern "C"
{

bool SKSEPlugin_Query(const SKSEInterface * skse, PluginInfo * info)
{
	//_MESSAGE("skse_double_cursor_fix_plugin");

	// populate info structure
	info->infoVersion =	PluginInfo::kInfoVersion;
	info->name =		"DCF_plugin";
	info->version =		1;

	// store plugin handle so we can identify ourselves later
	//g_pluginHandle = skse->GetPluginHandle();

	if(skse->isEditor)
	{
		//_MESSAGE("editor not supported");
		return false;
	}
	return true;
}

bool SKSEPlugin_Load(const SKSEInterface * skse)
{
	//_MESSAGE("load");

	hThread = (HANDLE)_beginthreadex(NULL,NULL,MyThreadProc,NULL,NULL,NULL);

	return true;
}

};
